from item import Item

class Inventory:
    def __init__(self, item_db : dict):
        self.items   : list[str]      = []
        self.item_db : dict[str,Item] = {}

        for id in item_db:
            item = item_db[id]
            self.item_db[id] = Item(id, item['name'], item['description'])

    def add_item(self, item):
        self.items.append(item)

    def has_item(self, id: str) -> bool:
        return id in self.items

    def get_items(self) -> list[Item]:
        items = []
        for id in self.items:
            items.append(self.item_db[id])
        
        return items

    def remove_item(self, item : str):
        if item.lower().strip() in self.items:
            self.items.remove(item.lower().strip())

    def get_item(self, id : str) -> None|Item:
        if id in self.item_db and id in self.items:
            return self.item_db[id]
        else:
            return None
    
    def get_item_by_name(self, name : str) -> Item|None:
        for id in self.item_db:
            item = self.item_db[id]
            if name.lower().strip() in item.name.lower().strip():
                return item
        
        return None